package namespace

import "errors"

var (
	ErrNoNamespace = errors.New("that namespace does not exist")
)

type Repository interface {
	Create(namespace Namespace) (*Namespace, error)
	All() ([]Namespace, error)
	GetByName(name string) (*Namespace, error)
	Update(id int64, namespace Namespace) (*Namespace, error)
	Delete(id int64) error
}
